#include<stdio.h>


template<class T>
class auto_ref{
	struct item_st{	
		int count;
		T obj;
	}*data_ref;
	class Proxy {
		item_st *ref;
    public:
 		Proxy(item_st* obj):ref(obj) {
			printf("lock\n");
		}
		~Proxy() {
			printf("unlock\n");
		}
		T* operator->() 
		{
			return &ref->obj;
		}
    };
	void Free(item_st *ref) {
		if(!ref) return;
		if(!--ref->count) delete ref;
	}
	void New() {		
		if(data_ref) return;
		data_ref=new item_st; 
		data_ref->count=1;
	}
public:
	auto_ref &operator =(auto_ref &obj) {
		item_st *temp=data_ref;
		data_ref=obj.data_ref;
		if(data_ref) data_ref->count++;
		Free(temp);
		return *this;
	}
	auto_ref &operator =(const T &obj) {
		New();
		data_ref->obj=obj;
		return &this;
	}
	Proxy operator ->() { 
		New(); 
		return Proxy(data_ref);
	}
	operator T&() {
		New();
		return data_ref->obj;
	}
	operator T*() {
		New();
		return &data_ref->obj;
	}
	auto_ref() { 
		data_ref=0;
	}
	auto_ref(auto_ref &obj) {
		operator=(obj);
	}
	~auto_ref() {
		Free(data_ref);
	}
};


class Test{
public:
	void test()
	{
		printf("test\n");
	}
};


void main()
{
	auto_ref<Test>obj;
	obj->test();
}

